#version 430 core
layout(location = 0) in vec3 aPos;
layout(location = 1) in vec3 aNormal;
layout(location = 3) in mat4 aInstanceModelMatrix;
layout(location = 7) in mat4 aInstanceNormalMatrix;


uniform mat4 pvMatrix;
uniform mat4 shadowPvMatrix;
uniform mat4 modelMatrix;
uniform mat4 normalMatrix;



out vec3 oPos;
out vec3 oNormal;
out vec4 oShadowCoord;


void main() {
    oNormal = vec3(aInstanceNormalMatrix * normalMatrix * vec4(aNormal, 1.0f));
	oPos = vec3(aInstanceModelMatrix * modelMatrix * vec4(aPos, 1.0f));

	oShadowCoord = shadowPvMatrix * vec4(oPos, 1.0f);
    gl_Position = pvMatrix * vec4(oPos, 1.0f);
}